var normapi = require('normapi');
var request = require('request')
const config = require('./config')

module.exports = (defaults) => {

  var API = new normapi()

  var check = function(object) {
    return new Promise((resolve, reject) => {
        let URL = config.checkIfLoggedInURL + defaults.appid
        request.post({
          headers: {
            'content-type': 'application/json'
          },
          url: URL,
          form: {
            uniquekey: object.logged_user,
            fingerprint: object.fingerprint,
            lalo: object.location
          }
        }, function(err, res, body) {
          if(err) reject({func: '@graphedCheckLogin-CHECK', type:'connection-error', msg: 'Sikertelen csatlakozás a GRAPHED szerverhez!', lCode: '-E1'})
          try {
            body = JSON.parse(body)
            resolve({func: '@graphedCheckLogin-CHECK', msg:'Sikeres ellenőrzés', lCode: '-S', document: body})
          }
          catch(e){
            reject({func: '@graphedCheckLogin-CHECK', type: 'parse-error', msg: 'Hiba a GRAPHED válasz feldolgozása közben!', lCode: '-E2'})
          }
        })
    })
  }
  var refresh = function(object) {
    return new Promise((resolve, reject) => {
        let URL = config.refreshURL
        request.post({
          headers: {
            'content-type': 'application/json'
          },
          url: URL,
          form: {
            uniquekey: object.logged_user,
            lalo: object.location
          }
        }, function(err, res, body) {
          if(err) reject({func: '@graphedCheckLogin-REFRESH', type:'connection-error', msg: 'Sikertelen csatlakozás a GRAPHED szerverhez!', lCode: '-E1'})
          try {
            body = JSON.parse(body)
            resolve({func: '@graphedCheckLogin-REFRESH', msg:'Bejelentkezve!', lCode: '-S1', document: body0})
          }
          catch(e){
            reject({func: '@graphedCheckLogin-REFRESH', type: 'parse-error', msg: 'Hiba a GRAPHED válasz feldolgozása közben!', lCode: '-E2'})
          }
        })
    })
  }

  API.addFunction({name: 'check', schema: {
    required: [
      'logged_user',  // uniquekey
      'fingerprint',  // fingerprint
      'location'],    // location
    properties: {
      logged_user: {
        type: 'string'
      },
      fingerprint: {
        type: 'string'
      },
      location: {
        type: 'string'
      }
    }
  }}, check)
  API.addFunction({
    name: 'refresh',
    schema: {
      required: [
        'logged_user',  // uniquekey
        'location'],    // location
      properties: {
        logged_user: {
          type: 'string'
        },
        location: {
          type: 'string'
        }
      }
    }
  }, refresh)

  return API
}
