const authDebug = require('debug')('graphed:functionAuth')
const config = require('./config')
const path = require('path')
const normapi = require('normapi')
const request = require('request')

let api = new normapi()

const authenticateFunction = object => {
  return new Promise(function(resolve, reject) {
    const url = path.join(config.functionAuth, defaults.appId)
    request.post({
      headers: {
        'content-type': 'application/x-www-form-urlencoded'
      },
      url: url,
      form: {
        function: object.function,
        adminclass: object.adminClass
      }
    }
    , (err, res, body) => {
      authDebug(body)
      if(err) reject({
        type:'request-error', 
        func: '@autenticateFunction', 
        lCode: '-E1',
        msg: 'Hiba a szerver csatlakozás közben!', 
        document: object.function
      })
      try {
        body = JSON.parse(body)
        if(body.access != true) reject({
          type: 'authentication-error',
          func: '@authenticateFunction',
          lCode: '-E2',
          msg: 'Nincs hozzáférése a funkcióhoz!',
          document: object.function, 
        })
        else resolve({
          func: '@authenticateFunction',
          lCode: '-S1'
        })
      } 
      catch (e) {reject(e)}
    })
  })
}

api.addFunction({name: 'authenticateFunction'}, authenticateFunction)

module.exports = api