var normapi = require('normapi');
const request = require('request')
const config = require('./config')
module.exports = (defaults) => {

  var API = new normapi()

  let uploadFunctions = (apis) => {
    return new Promise((resolve, reject) => {
      let createArray = new Promise((fulfill, rej) => {
        var arr = []
        apis.forEach((api) => {
          api.functions.forEach((func) => {
            arr.push({
              functionname: func.name,
              functionid: (config.DEVELOPERAUTH ? 'd' : '') + api.lCode + func.lCode
            })
          })
        })
        fulfill(arr)
        if(false)
          rej()
      })
      createArray.then((functions) => {
        let URL = gConfig.functionUploadURL + defaults.appid
        request.post({
          headers: {'content-type': 'application/x-www-form-urlencoded'},
          url: URL,
          form: {
            functions: functions
          }
        },
          (err, res, body) => {
            try {
              body = JSON.parse(body)
              if (err || body.error) { reject({lCode: '-E', document: body}) } else { resolve({lCode: '-S', document: body}) }
            } catch (e) {
              console.log(e)
              console.log(body)
              reject({lCode: '-E', document: e})
            }
          })
      })
    })
  }

  let getAdminclasses = (uniquekey) => {
    return new Promise((resolve, reject) => {
      let URL = gConfig.getAdminClasses + defaults.appid
      request.post({
        headers: {'content-type': 'application/x-www-form-urlencoded'},
        url: URL,
        form: {
          uniquekey : uniquekey
        }
      },
      (err, res, body) => {
        try {
          body = JSON.parse(body)
          if(body.error)
            reject({lCode: body.msg, document: null})
          else
            resolve({lCode: "-S", document: body.classes})
        } catch (e) {
          reject({lCode: "m2", document: null})
          console.log(body)
        }
      })
    })
  }
  let getAllFunctions = (uniquekey) => {
    return new Promise((resolve, reject) => {
      let URL = gConfig.getAllFunctions + defaults.appid
      request.post({
        headers: {'content-type': 'application/x-www-form-urlencoded'},
        url: URL,
        form: {
          uniquekey : uniquekey
        }
      },
      (err, res, body) => {
        body = JSON.parse(body)
        if(body.error)
          reject({lCode: body.msg, document: null})
        else
          resolve({lCode: "-S", document: body.functions})
      })
    })
  }

  let editfunctions = (data) => {
    let success = true
    return new Promise((resolve, reject) => {
      let disable = new Promise((fulfill, rej) => {
        let URL = gConfig.banFunctions + defaults.appid
        if(data.functions.ban.length > 0)
          request.post({
            headers: {'content-type': 'application/x-www-form-urlencoded'},
            url: URL,
            form: {
              ids: data.functions.ban,
              adminclass: data.adminclass,
              uniquekey: data.uniquekey
            }
          },
          (err, res, body) => {
            body = JSON.parse(body)
            success = success && body.error
            fulfill(body)
          })
        else
          fulfill({msg: 'Nothing to disable'})
      })

      let enable = new Promise((fulfill, rej) => {
        URL = gConfig.enableFunctions + defaults.appid
        if(data.functions.enable.length > 0)
          request.post({
            headers: {'content-type': 'application/x-www-form-urlencoded'},
            url: URL,
            form: {
              ids: data.functions.enable,
              adminclass: data.adminclass,
              uniquekey: data.uniquekey
            }
          },
          (err, res, body) => {
            body = JSON.parse(body)
            success = success && body.error
            fulfill(body)
          })
        else
          fulfill({msg: 'Nothing to enable'})
      })
      enable.then((e) => {
        disable.then((d) => {
          resolve({lCode: '-M', document: {ban: d, enable: e}})
        })
        .catch((d) => {
          reject({lCode: '-M', document: {ban: d, enable: e}})
        })
      }).catch((e) => {
        disable.then((d) => {
          reject({lCode: '-M', document: {ban: d, enable: e}})
        })
        .catch((d) => {
          reject({lCode: '-M1', document: {ban: d, enable: e}})
        })
      })
    })
  }

  let isFunctionEnabled = (functiondefaults) => {
    return new Promise((resolve, reject) => {
      let URL = gConfig.isFunctionEnabled + defaults.appid
      request.post({
        headers: {'content-type': 'application/x-www-form-urlencoded'},
        url: URL,
        form: {
          function : functiondefaults.func,
          adminclass : functiondefaults.adminclass
        }
      },
      (err, res, body) => {
        try {
          body = JSON.parse(body)
          resolve({lCode: '-S', document: {functionid: functiondefaults.func, access: body.access}})
        }
        catch (e) {
          console.log(e)
          console.log(body)
          reject({lCode: '-E', document: {functionid: functiondefaults.func, access: false}})
        }
      })
    })
  }
  API.addFunction({name: 'uploadFunctions'}, uploadFunctions)
  API.addFunction({name: 'getAdminClasses'}, getAdminclasses)
  API.addFunction({name: 'getAllFunctions'}, getAllFunctions)
  API.addFunction({name: 'editFunctions'}, editfunctions)
  API.addFunction({name: 'isFunctionEnabled'}, isFunctionEnabled)
  return API
}
